dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/level_up_wand2/files/my_utilities.lua")

local distance_full = 256

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

-- add_exp
local enemys = EntityGetInRadiusWithTag(x, y, distance_full, "enemy")
local wand = get_wand_id_hand( entity_id )

local serch_wand = GlobalsGetValue( "FreeRebirth","false" )

if serch_wand == "true" then 
	if ( wand ~= nil) then 
		local is_hack = EntityHasTag(wand, "WAZAP_wand_hack")

		if not is_hack then

			EntityAddComponent( wand, "LuaComponent", 
			{ 
		   	 _tags= "enabled_in_hand",
			script_source_file = "mods/level_up_wand2/files/scripts/right_click.lua",
			execute_every_n_frame = "1",
			})

			EntityAddTag(wand, "WAZAP_wand_hack")
			--GamePrint("wand_hack")
		end
	end
else

	if ( #enemys ~= 0) then 
		for _,id in ipairs(enemys) do	

			local is_exp = EntityHasTag(id, "exp")

			if not is_exp then

				EntityAddComponent(id,"LuaComponent",{ execute_every_n_frame="-1", script_death="mods/level_up_wand2/files/scripts/exp_get_death.lua", remove_after_executed="0"})
				EntityAddTag(id, "exp")
				GamePrint("enemy_hack")

			end
		end
	end
end

