dofile_once("mods/level_up_wand2/files/my_utilities.lua")
dofile_once("data/scripts/gun/procedural/gun_action_utils.lua")
dofile_once("data/scripts/lib/utilities.lua")
dofile( "data/scripts/game_helpers.lua" )
------------------------------------------------------------------------------------
function spawn_shuffle(sum_number)
	for i=5, 0, -1 do
		if sum_number >= i then
			local level = i + 1
			return "data/entities/items/wand_level_0"..tostring(level)
		end
	end
end

function spawn_unshuffle(sum_number)
	for i=5, 0, -1 do
		if sum_number >= i then
			local level = i + 1
			return "data/entities/items/wand_unshuffle_0"..tostring(level)
		end
	end
end

function deck_level (deck_full)
	if deck_full == 0 then
		local ward = "_rare.xml"
		return ward
	else
		local ward = ".xml"
		return ward
	end
end
		
-------------------------------------------------------------------------------------
local players = get_players()
local player_id = players[1]
local wand_hand_id = find_the_wand_held( get_player())

local ctrlcomp = EntityGetFirstComponentIncludingDisabled(player_id, "ControlsComponent")
local right_click = ComponentGetValue2(ctrlcomp, "mButtonDownRightClick")
local right_click_transform = ComponentGetValue2(ctrlcomp, "mButtonDownTransformRight")

if right_click then 
     
     Right_Click_Time = tonumber( GameGetFrameNum() )
     
     if Right_Click_Flag == nil then 
	     Right_Click_Flag = 1
	     Right_Click_Init_Time = tonumber(Right_Click_Time)
	     local testtext = "右クリック長押しで杖を転生"
	     GamePrint(testtext)
     end
     
	 if not right_click_transform then
		 
		local x, y = EntityGetTransform( wand_hand_id )
		
		local time_count = tonumber(Right_Click_Time) - tonumber(Right_Click_Init_Time)
		if time_count >= 180 then

			local abicomp = EntityGetFirstComponentIncludingDisabled(wand_hand_id, "AbilityComponent")
			if abicomp ~= nil then
				local capacity = tonumber(ComponentObjectGetValue( abicomp, "gun_config", "deck_capacity" ))
				local shuffle = tonumber(ComponentObjectGetValue( abicomp, "gun_config", "shuffle_deck_when_empty" ))
				local spell_count = wand_actions_id(wand_hand_id)
				local deck_full = capacity - #spell_count
						
				local capacity = tonumber(capacity) * 0.25
				local shuffle = tonumber(shuffle)
				local sum_number = capacity + shuffle
				local sum_number = sum_number - 0.5
				GamePrint("転生レベル"..tostring(sum_number))
				
			    if shuffle > 0 then 
					local is_level = spawn_unshuffle(sum_number)
					local is_rare = deck_level(deck_full)
					local spawn_level = is_level..is_rare

					EntityLoad(spawn_level, x, y)
					EntityLoad("data/entities/particles/image_emitters/chest_effect.xml", x, y)
					GamePrint(spawn_level)
					GameKillInventoryItem(player_id,wand_hand_id)
								    
			    else
					local is_level = spawn_shuffle(sum_number)
					local is_rare = deck_level(deck_full)
					local spawn_level = is_level..is_rare

					EntityLoad(spawn_level, x, y)
					EntityLoad("data/entities/particles/image_emitters/chest_effect.xml", x, y)
					GamePrint(spawn_level)
					GameKillInventoryItem(player_id,wand_hand_id)
				end
				
				shoot_projectile( player_id, "mods/level_up_wand2/files/test.xml", x, y, 0, 0 )
				
				local money = 10 * #spell_count
				local gold_entity = "data/entities/items/pickup/goldnugget_"
				local remove_timer = false
				local comp_worldstate = EntityGetFirstComponent( GameGetWorldStateEntity(), "WorldStateComponent" )
				if( comp_worldstate ~= nil ) then
					if( ComponentGetValue2( comp_worldstate, "perk_gold_is_forever" ) ) then
						remove_timer = true
					end
				end
				while money >= 10 do
					load_gold_entity( gold_entity .. "10.xml", x, y-8, remove_timer )
				money = money - 10
				end	
				
			else
				local testtext = "abicomp_is_nil"
                                print(testtext)
			end
		
   	 else 
        	--local testtext = "true_trunsform"
              	--print(testtext)
	end
        end

elseif Right_Click_Flag == 1 then
	--local testtext = "right_click_transform"
	      --print(testtext)
	Right_Click_Flag = nil	      
end

