dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/level_up_wand2/files/my_utilities.lua")
dofile_once("data/scripts/gun/procedural/gun_action_utils.lua")
dofile( "data/scripts/game_helpers.lua" )
-----------------------------------------------------------------------
function right_click_count(wand_actions, i)
	if wand_actions[i] == "MANA_OUTFLOW" then
		local outflow = 1
		return tonumber(outflow)
	else
		local outflow = 0
		return tonumber(outflow)
	end

end

function right_click_count2(wand_actions)
	local hacked_count = 0
	
	for i=1, #wand_actions do
		local wand_hacked = 0
		local wand_hacked = right_click_count(wand_actions, i)
		local hacked_count = hacked_count + wand_hacked
		if hacked_count >=1 then 
			return hacked_count
		end
		if i == #wand_actions then
			return hacked_count
		end
	end
	
end

function wand_hack(player_id, wand_id, x, y)
	local wand_actions= wand_actions_id(wand_id)	
	local wand_hacked = right_click_count2(wand_actions)
	
	if wand_hacked == 0 then
		local card = "MANA_OUTFLOW"
		AddGunActionPermanent( wand_id, card )

		EntityAddComponent( wand_id, "LuaComponent", 
		{ 
	    _tags= "enabled_in_hand",
		script_source_file = "mods/level_up_wand2/files/scripts/right_click.lua",
		execute_every_n_frame = "1",
		} )

	end
	
	local ward = "右クリック長押しで、杖が転生する"
	local particle = "mods/level_up_wand2/files/test.xml" --常時詠唱付与兼マナ液流出

	shoot_projectile( player_id, tostring(particle), x, y,0,0)
	GamePrintImportant( "杖のマナが失われた", ward )	
			
	EntityAddComponent( wand_id, "LuaComponent", 
	{ 
    _tags= "enabled_in_hand",
	script_source_file = "mods/level_up_wand2/files/scripts/mana_reduce.lua",
	execute_every_n_frame = "1",
	remove_after_executed = "1"
	} )
end
