table.insert( perk_list,	
	{
		id = "WAZAP_MANA",
		ui_name = "マナ流出の無効化",
		ui_description = "杖成長時のマナチャ減少を無効化する", -- does nothing
		ui_icon = "data/ui_gfx/material_indicators/hp_regeneration.png",
		perk_icon = "data/items_gfx/perks/mystery_eggplant.png",
		not_in_default_perk_pool = true, -- if set, this perk only materializes when manually spawned, e.g. when calling spawn_perk("MYSTERY_EGGPLANT") somewhere
		func = function( entity_perk_item, entity_who_picked, item_name )
		GlobalsSetValue( "MANA_OUTFLOW_DELETE", "true" )
		end
	})

table.insert( perk_list,	
	{
		id = "WAZAP_REBIRTH",
		ui_name = "いつでも杖転生",
		ui_description = "杖成長無しでいつでも杖転生ができる", -- does nothing
		ui_icon = "data/ui_gfx/material_indicators/hp_regeneration.png",
		perk_icon = "data/items_gfx/perks/mystery_eggplant.png",
		not_in_default_perk_pool = true, -- if set, this perk only materializes when manually spawned, e.g. when calling spawn_perk("MYSTERY_EGGPLANT") somewhere
		func = function( entity_perk_item, entity_who_picked, item_name )
		GlobalsSetValue( "FreeRebirth", "true" )
		end
	})