dofile_once( "mods/level_up_wand2/files/my_utilities.lua" )

function item_pickup( entity_item, entity_who_picked, item_name )
	local pos_x, pos_y = EntityGetTransform( entity_item )
	local wand_id = get_wand_id_hand(entity_who_picked)

	local abicomp = EntityGetFirstComponentIncludingDisabled(wand_id, "AbilityComponent")

	if abicomp ~= nil then
		local mana_charge = tonumber(ComponentGetValue2( abicomp, "mana_charge_speed" ))

		if mana_charge <= 10 then
			local new_mana = 100
			ComponentSetValue(abicomp, "mana_charge_speed", new_mana)
		end
	end

        wand_remove_first_permanently ( wand_id )
	-- spawn a new one
	EntityKill( entity_item )
	EntityLoad( "data/entities/particles/perk_reroll.xml", pos_x, pos_y )

end
